POJ3126 - Prime Path

来源:互联网 发布:51单片机控制舵机 编辑:程序博客网 时间:2024/05/19 02:27

                                                                                                                 Prime Path

Time Limit:1000MS    Memory Limit:65536KB    64bit IO Format:%lld & %llu

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670

这道题目的大意就是给出两个数字,都是素数,要求求前面那个数字转化为后面那个数字的步数。转化规则是,每次只能变当前数字的某一位数字,且生成一个数字后则个数字仍是素数。

这道题看得出就是个广搜的题目,合理运用BFS就能解出来。考虑到1000到10000的素数只有1061个,时间复杂度可以算作是100*1000*1000,每次都遍历一次这些素数看看是不是有一个数字不同其他相同

#include<cstdio>#include<queue>#include<cmath>#include<cstring>using namespace std;int prime[10000],k,a,b;bool mark[10000],flag;struct node{int x;int Step_Count;};bool Check(int x,int y){int cout=0;while(x>0){if(x%10==y%10)cout++;x/=10;y/=10;}if(cout==3)return 1;elsereturn 0;}void bfs(){node now,next;queue <node> q;now.x=a;now.Step_Count=0;q.push(now);while(!q.empty()){now=q.front();if(now.x==b){printf("%d\n",now.Step_Count);flag=1;return;}for(int i=0;i<k;i++){if(!mark[i] && Check(now.x,prime[i])){next.x=prime[i];next.Step_Count=now.Step_Count+1;q.push(next);mark[i]=1;}}q.pop();}}int main(){int i,j,t,T;for(i=1000;i<10000;i++){flag=1;t=sqrt(i);for(j=2;j<=t;j++){if(i%j==0){flag=0;break;}}if(flag)prime[k++]=i;}scanf("%d",&T);while(T--){flag=0;scanf("%d%d",&a,&b);memset(mark,0,sizeof(mark));bfs();if(flag==0)printf("0\n");}return 0;}




0 0